/********************************************************

      FDTD 2D Benchmark Problem 1: Version No.006

Made by Takenobu Tsuchiya ( Kanagawa University )
********************************************************/

/*O[oϐ錾*/

#define	X_m_max	3200		/*vZ̈̍őObh*/
#define	Y_m_max	3200		/*vZ̈̍őObh*/
#define	T_max_m	5000

static	double	P1[X_m_max][Y_m_max];
static	double	Vx[X_m_max][Y_m_max];
static	double	Vy[X_m_max][Y_m_max];
static	double	PX1[6][Y_m_max];
static	double	PY1[6][X_m_max];
static	double	PX2[6][Y_m_max];
static	double	PY2[6][X_m_max];
static	double	amp1[T_max_m],amp2[T_max_m];

static	double	f, dx, dt, range, depth, cal_time;
static	double	rou0, c0, gensui0, absp0, alpha0, kap0, hasu0, c_m0, hasu_o0;
static	double	Cp1, Cp2, Cv1, Cv2;
static	double	Ca0, Ca1, Ca2, Cah1, Cah2, a1, a2, d1, d2;
static	double	PI = 3.14159265359;

static	int		i, j, T, del_T, l, m, n, x_max, y_max, T_max;
static	int		i_min, i_max, j_min, j_max, W_end, WN;
static	int		SX, SY, RX, RY, SC, BC;
static	double	sd, rd, bd, rds;
static	int		ng,mg;

/********* Include files *******************************/
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<math.h>
#include	"fdtd_func.h"
#include	"boundary.h"


/************ ̌vZ ************************************/
void	Pressure(void)
{

	for( i = 1 ; i <= x_max -2  ; ++i )	{
		for( j = 1 ; j <= y_max - 2 ; ++j )	{
			if(i == SX && j == SY && T <= W_end)
				{
					P1[i][j]=Driver(T);
				}
				else
				{
					P1[i][j] = Cp1*P1[i][j] - Cp2*(Vx[i][j]-Vx[i-1][j]+Vy[i][j]-Vy[i][j-1]);
				}
		}
	}


}

 
/******** qx̌vZ ****************************/
void	Velocity(void)
{


	for( i = 0 ; i <= x_max -2 ; ++i )
	{
		for( j = 1 ; j <= y_max - 2 ; ++j )	
		{
	
				Vx[i][j] = Cv1*Vx[i][j] - Cv2*(P1[i+1][j]-P1[i][j]);

		}
	}

	for( i = 1 ; i <= x_max -2 ; ++i )
	{
		for( j = 0 ; j <= y_max - 2 ; ++j )	
		{

				Vy[i][j] = Cv1*Vy[i][j] - Cv2*(P1[i][j+1]-P1[i][j]);

		}
	}

}





void	main(void)
{
	printf("\n**************** 2D FD-TD *******************\n");
	printf("   Starting simulation of sound propagation\n\n");

	Make_param();
	Initialize();

	printf(" \n Model parameter\n");
	printf("   Frequency = %f[Hz]\n",(float)f);
	printf("   Range = %f[m]\n",(float)range);
	printf("   Depth = %f[m]\n",(float)depth);
	printf(" \n Grid parameter\n");
	printf("   dx = %f[mm]\n",(float)dx*1000);
	printf("   dt = %f[ms]\n\n",(float)dt*1000);

/*****main calculation loop strat******/
	for( T = 0 ; T <= T_max ; ++T )
	{

		Pressure();
		boundary();
		Velocity();
		WaveT();

/*		printf(" T = %d\n",T);*/
		if(T%(T_max/50) == 0)
		{
			printf("  %4d%% calculation complite\n",T*100/T_max);
		}

		if( T%del_T==0 && T >= del_T )	
		{
			FieldSnap();
		}

	}
/*****main calculation loop end******/

		OutputF();
		OutputW();
		printf("\n  calculation complite !\n\n");
}
